﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;

namespace xamDataTree1
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void xamDataTree1_InitializeNode(object sender, Infragistics.Controls.Menus.InitializeNodeEventArgs e)
        {
            Continent continent = e.Node.Data as Continent;
            if (continent != null)
            {
                if (continent.Name == "Australia")
                {
                    return;
                }
            }
            e.Node.IsDraggable = true;
            e.Node.IsDropTarget = true;
        }
    }

    #region Data
    public class ContinentCollection : ObservableCollection<Continent>
    {
        public ContinentCollection()
        {
            Add(
                new Continent
                {
                    Name = "Africa",
                    Countres = new ObservableCollection<Country>()
                    {
                        new Country()
                        {
                            Name = "Algeria",
                            Cities = new ObservableCollection<City>()
                            {
                                new City {Name = "Algiers"},
                                new City {Name = "Oran"},
                            }
                        },
                        new Country()
                        {
                            Name = "Angola",
                            Cities = new ObservableCollection<City>()
                            {
                                new City {Name = "Soyo"},
                                new City {Name = "Ndalatando"},
                                new City {Name = "Ambriz"},
                            }
                        },
                        new Country()
                        {
                            Name = "Cape Verde",
                            Cities = new ObservableCollection<City>()
                            {
                                new City {Name = "Mindelo"},
                                new City {Name = "Assomada"},
                            }
                        }
                    }
                });

            Add(
                new Continent
                {
                    Name = "Asia",
                    Countres = new ObservableCollection<Country>()
                                    {
                                        new Country()
                                        {
                                            Name = "Cambodia",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Phnom Penh"},
                                                new City {Name = "Koh Kong"},
                                            }
                                        },
                                        new Country()
                                        {
                                            Name = "China",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Shanghai"},
                                                new City {Name = "Beijing"},
                                                new City {Name = "Tianjin"},
                                            }
                                        },
                                        new Country()
                                        {
                                            Name = "Japan",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Tokyo"},
                                                new City {Name = "Yokohama"},
                                                new City {Name = "Sapporo"},
                                            }
                                        }
                                    }
                });

            Add(new Continent
            {
                Name = "Australia",
                Countres = new ObservableCollection<Country>()
                                    {
                                        new Country()
                                        {
                                            Name = "Australia",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Sydney"},
                                                new City {Name = "Melbourne"},
                                                new City {Name = "Perth"},
                                            }
                                        }
                                    }
            });

            Add(new Continent
            {
                Name = "Europe",
                Countres = new ObservableCollection<Country>()
                                    {
                                        new Country()
                                        {
                                            Name = "Germany",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Berlin"},
                                                new City {Name = "Hamburg"}
                                            }
                                        },
                                        new Country()
                                        {
                                            Name = "Italy",
                                            Cities = new ObservableCollection<City>()
                                            {
                                                new City {Name = "Milan"},
                                                new City {Name = "Naples"},
                                                new City {Name = "Rome"}
                                            }
                                        }
                                    }
            });
        }
    }

    public class Continent
    {
        public string Name { get; set; }
        public ObservableCollection<Country> Countres { get; set; }
    }

    public class Country
    {
        public string Name { get; set; }
        public ObservableCollection<City> Cities { get; set; }
    }

    public class City
    {
        public string Name { get; set; }
    }

    public class Operator
    {
        public int ID { get; set; }
        public string Name { get; set; }
    }
    #endregion  


}
